
#include <stdbool.h>
#include <stdint.h>
#include "spi_master.h"
#include "nrf_delay.h"
#include "common.h"
#include "nrf_gpio.h"
#include "boards.h"
#include "spi_master_config.h"
#include "nrf51.h"
#include "simple_uart.h"

#define TX_BUF_SIZE  100;
#define RX_BUF_SIZE  100;

uint8_t spi_rx_data;

int main(void)
{
	simple_uart_config(RTS_PIN_NUMBER, TX_PIN_NUMBER, CTS_PIN_NUMBER, RX_PIN_NUMBER, HWFC);
	
	nrf_gpio_cfg_output(TX_PIN_NUMBER);
	nrf_gpio_cfg_output(LED_0);
	nrf_gpio_cfg_output(LED_1);
	
	NRF_UART0->PSELTXD = TX_PIN_NUMBER;	
	NRF_UART0->BAUDRATE = 0x009D5000;	
	NRF_UART0->TASKS_STARTTX = 1;		
	NRF_UART0->ENABLE = (UART_ENABLE_ENABLE_Enabled << UART_ENABLE_ENABLE_Pos);
	NRF_UART0->EVENTS_TXDRDY=0;
	NRF_UART0->PSELCTS = 0xFF;
  NRF_UART0->PSELRXD = 0xFF;
  NRF_UART0->PSELRTS = 0xFF;		
	NRF_UART0->CONFIG = (UART_CONFIG_HWFC_Disabled << UART_CONFIG_HWFC_Pos);
	
	NRF_SPIS1->PSELSCK  = SPI_PSELSCK0;
	NRF_SPIS1->PSELMISO = SPI_PSELMISO0;	
	NRF_SPIS1->ENABLE =  010;
//	NRF_SPIS1->SEMSTAT = 10;
	NRF_SPIS1->CONFIG = 100;
	NRF_SPIS1->MAXRX = 1;
			
	while(true)
	{		
		NRF_SPIS1->TASKS_ACQUIRE = 1;  
		NRF_SPIS1->EVENTS_ACQUIRED = 1;
		
		NRF_SPIS1->TXDPTR = 'z';		
		spi_rx_data = NRF_SPIS1->RXDPTR;	
					
		nrf_gpio_pin_set(LED_0);
		nrf_gpio_pin_clear(LED_1);
			  
		NRF_SPIS1->TASKS_RELEASE = 1;
		
		NRF_UART0->TXD = spi_rx_data;
		
		nrf_delay_ms(500);
		
		while (NRF_UART0->EVENTS_TXDRDY!=1)
		{   
		}
		NRF_UART0->EVENTS_TXDRDY=0;
		
		nrf_gpio_pin_clear(LED_0);
		nrf_gpio_pin_set(LED_1);
		
		nrf_delay_ms(500);		
	}	
}